
  include:
 - template: Terraform/Base.gitlab-ci.yml 
 
 stages:
 - prepare
 - validate
 - plan
 - apply
 
 variables:
 AWS_ACCESS_KEY_ID: $AWS_ACCESS_KEY_ID
 AWS_SECRET_ACCESS_KEY: $AWS_SECRET_ACCESS_KEY
 AWS_DEFAULT_REGION: "ca-central-1"
 
 prepare:
 stage: prepare
 script:
  - |
     cat > user_data.tf <<EOF
     variable "user_data" {
       default = <<-EOF
       #!/bin/bash
       sudo yum update -y
       sudo yum install -y httpd
       sudo systemctl start httpd
       sudo systemctl enable httpd
       sudo amazon-linux-extras install -y nginx1.12
sudo systemctl start nginx
sudo systemctl enable nginx
sudo yum install -y httpd
sudo systemctl start httpd
sudo systemctl enable httpd
EOF
     }
     EOF
 artifacts:
  paths:
     - user_data.tf
 
 validate:
 stage: validate
 script:
  - terraform init
  - terraform validate
 dependencies:
  - prepare
 
 plan:
 stage: plan
 script:
  - terraform plan -out=tfplan
 artifacts:
  paths:
     - tfplan
 dependencies:
  - prepare
 
 apply:
 stage: apply
 script:
  - terraform apply -auto-approve tfplan
 dependencies:
  - plan
 